Package io.vertx.rxjava3.core.file

## Class FileSystem

- java.lang.Object
- - io.vertx.rxjava3.core.file.FileSystem

-     public class FileSystem
      extends Object

  Contains a broad set of operations for manipulating files on the file system.

  A (potential) blocking and non blocking version of each operation is provided.

  The non blocking versions take a handler which is called when the operation completes or an error occurs.

  The blocking versions are named `xxxBlocking` and return the results, or throw exceptions directly. In many cases, depending on the operating system and file system some of the potentially blocking operations can return quickly, which is why we provide them, but it's highly recommended that you test how long they take to return in your particular application before using them on an event loop.

  Please consult the documentation for more information on file system support.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<FileSystem>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FileSystem​(FileSystem delegate)` |
    `FileSystem​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Completable` | `chmod​(String path, String perms)` | Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chmodBlocking​(String path, String perms)` | Blocking version of `#chmod(String, String)`
    `Completable` | `chmodRecursive​(String path, String perms, String dirPerms)` | Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `FileSystem` | `chmodRecursiveBlocking​(String path, String perms, String dirPerms)` | Blocking version of `chmodRecursive(java.lang.String, java.lang.String, java.lang.String)`
    `Completable` | `chown​(String path, String user, String group)` | Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
    `FileSystem` | `chownBlocking​(String path, String user, String group)` | Blocking version of `chown(java.lang.String, java.lang.String, java.lang.String)`
    `Completable` | `copy​(String from, String to)` | Copy a file from the path `from` to path `to`, asynchronously.
    `Completable` | `copy​(String from, String to, CopyOptions options)` | Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `copyBlocking​(String from, String to)` | Blocking version of `copy(java.lang.String, java.lang.String)`
    `Completable` | `copyRecursive​(String from, String to, boolean recursive)` | Copy a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `copyRecursiveBlocking​(String from, String to, boolean recursive)` | Blocking version of `copyRecursive(java.lang.String, java.lang.String, boolean)`
    `Completable` | `createFile​(String path)` | Creates an empty file with the specified `path`, asynchronously.
    `Completable` | `createFile​(String path, String perms)` | Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
    `FileSystem` | `createFileBlocking​(String path)` | Blocking version of `createFile(java.lang.String)`
    `FileSystem` | `createFileBlocking​(String path, String perms)` | Blocking version of `createFile(java.lang.String)`
    `Single<String>` | `createTempDirectory​(String prefix)` | Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.
    `Single<String>` | `createTempDirectory​(String prefix, String perms)` | Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.
    `Single<String>` | `createTempDirectory​(String dir, String prefix, String perms)` | Creates a new directory in the directory provided by the path `path`, using the given prefix to generate its name, asynchronously.
    `String` | `createTempDirectoryBlocking​(String prefix)` | Blocking version of `createTempDirectory(java.lang.String)`
    `String` | `createTempDirectoryBlocking​(String prefix, String perms)` | Blocking version of `createTempDirectory(java.lang.String)`
    `String` | `createTempDirectoryBlocking​(String dir, String prefix, String perms)` | Blocking version of `createTempDirectory(java.lang.String)`
    `Single<String>` | `createTempFile​(String prefix, String suffix)` | Creates a new file in the default temporary-file directory, using the given prefix and suffix to generate its name, asynchronously.
    `Single<String>` | `createTempFile​(String prefix, String suffix, String perms)` | Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.
    `Single<String>` | `createTempFile​(String dir, String prefix, String suffix, String perms)` | Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.
    `String` | `createTempFileBlocking​(String prefix, String suffix)` | Blocking version of `createTempFile(java.lang.String, java.lang.String)`
    `String` | `createTempFileBlocking​(String prefix, String suffix, String perms)` | Blocking version of `createTempFile(java.lang.String, java.lang.String)`
    `String` | `createTempFileBlocking​(String dir, String prefix, String suffix, String perms)` | Blocking version of `createTempFile(java.lang.String, java.lang.String)`
    `Completable` | `delete​(String path)` | Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `deleteBlocking​(String path)` | Blocking version of `delete(java.lang.String)`
    `Completable` | `deleteRecursive​(String path, boolean recursive)` | Deletes the file represented by the specified `path`, asynchronously.
    `FileSystem` | `deleteRecursiveBlocking​(String path, boolean recursive)` | Blocking version of `deleteRecursive(java.lang.String, boolean)`
    `boolean` | `equals​(Object o)` |
    `Single<Boolean>` | `exists​(String path)` | Determines whether the file as specified by the path `path` exists, asynchronously.
    `boolean` | `existsBlocking​(String path)` | Blocking version of `exists(java.lang.String)`
    `Single<FileSystemProps>` | `fsProps​(String path)` | Returns properties of the file-system being used by the specified `path`, asynchronously.
    `FileSystemProps` | `fsPropsBlocking​(String path)` | Blocking version of `fsProps(java.lang.String)`
    `FileSystem` | `getDelegate()` |
    `int` | `hashCode()` |
    `Completable` | `link​(String link, String existing)` | Create a hard link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `linkBlocking​(String link, String existing)` | Blocking version of `link(java.lang.String, java.lang.String)`
    `Single<FileProps>` | `lprops​(String path)` | Obtain properties for the link represented by `path`, asynchronously.
    `FileProps` | `lpropsBlocking​(String path)` | Blocking version of `lprops(java.lang.String)`
    `Completable` | `mkdir​(String path)` | Create the directory represented by `path`, asynchronously.
    `Completable` | `mkdir​(String path, String perms)` | Create the directory represented by `path`, asynchronously.
    `FileSystem` | `mkdirBlocking​(String path)` | Blocking version of `mkdir(java.lang.String)`
    `FileSystem` | `mkdirBlocking​(String path, String perms)` | Blocking version of `mkdir(java.lang.String)`
    `Completable` | `mkdirs​(String path)` | Create the directory represented by `path` and any non existent parents, asynchronously.
    `Completable` | `mkdirs​(String path, String perms)` | Create the directory represented by `path` and any non existent parents, asynchronously.
    `FileSystem` | `mkdirsBlocking​(String path)` | Blocking version of `mkdirs(java.lang.String)`
    `FileSystem` | `mkdirsBlocking​(String path, String perms)` | Blocking version of `mkdirs(java.lang.String)`
    `Completable` | `move​(String from, String to)` | Move a file from the path `from` to path `to`, asynchronously.
    `Completable` | `move​(String from, String to, CopyOptions options)` | Move a file from the path `from` to path `to`, asynchronously.
    `FileSystem` | `moveBlocking​(String from, String to)` | Blocking version of `move(java.lang.String, java.lang.String)`
    `static FileSystem` | `newInstance​(FileSystem arg)` |
    `Single<AsyncFile>` | `open​(String path, OpenOptions options)` | Open the file represented by `path`, asynchronously.
    `AsyncFile` | `openBlocking​(String path, OpenOptions options)` | Blocking version of `open(java.lang.String, io.vertx.core.file.OpenOptions)`
    `Single<FileProps>` | `props​(String path)` | Obtain properties for the file represented by `path`, asynchronously.
    `FileProps` | `propsBlocking​(String path)` | Blocking version of `props(java.lang.String)`
    `Single<List<String>>` | `readDir​(String path)` | Read the contents of the directory specified by `path`, asynchronously.
    `Single<List<String>>` | `readDir​(String path, String filter)` | Read the contents of the directory specified by `path`, asynchronously.
    `List<String>` | `readDirBlocking​(String path)` | Blocking version of `readDir(java.lang.String)`
    `List<String>` | `readDirBlocking​(String path, String filter)` | Blocking version of `readDir(java.lang.String)`
    `Single<Buffer>` | `readFile​(String path)` | Reads the entire file as represented by the path `path` as a , asynchronously.
    `Buffer` | `readFileBlocking​(String path)` | Blocking version of `readFile(java.lang.String)`
    `Single<String>` | `readSymlink​(String link)` | Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
    `String` | `readSymlinkBlocking​(String link)` | Blocking version of `readSymlink(java.lang.String)`
    `Completable` | `rxChmod​(String path, String perms)` | Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `Completable` | `rxChmodRecursive​(String path, String perms, String dirPerms)` | Change the permissions on the file represented by `path` to `perms`, asynchronously.
    `Completable` | `rxChown​(String path, String user, String group)` | Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
    `Completable` | `rxCopy​(String from, String to)` | Copy a file from the path `from` to path `to`, asynchronously.
    `Completable` | `rxCopy​(String from, String to, CopyOptions options)` | Copy a file from the path `from` to path `to`, asynchronously.
    `Completable` | `rxCopyRecursive​(String from, String to, boolean recursive)` | Copy a file from the path `from` to path `to`, asynchronously.
    `Completable` | `rxCreateFile​(String path)` | Creates an empty file with the specified `path`, asynchronously.
    `Completable` | `rxCreateFile​(String path, String perms)` | Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
    `Single<String>` | `rxCreateTempDirectory​(String prefix)` | Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.
    `Single<String>` | `rxCreateTempDirectory​(String prefix, String perms)` | Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.
    `Single<String>` | `rxCreateTempDirectory​(String dir, String prefix, String perms)` | Creates a new directory in the directory provided by the path `path`, using the given prefix to generate its name, asynchronously.
    `Single<String>` | `rxCreateTempFile​(String prefix, String suffix)` | Creates a new file in the default temporary-file directory, using the given prefix and suffix to generate its name, asynchronously.
    `Single<String>` | `rxCreateTempFile​(String prefix, String suffix, String perms)` | Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.
    `Single<String>` | `rxCreateTempFile​(String dir, String prefix, String suffix, String perms)` | Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.
    `Completable` | `rxDelete​(String path)` | Deletes the file represented by the specified `path`, asynchronously.
    `Completable` | `rxDeleteRecursive​(String path, boolean recursive)` | Deletes the file represented by the specified `path`, asynchronously.
    `Single<Boolean>` | `rxExists​(String path)` | Determines whether the file as specified by the path `path` exists, asynchronously.
    `Single<FileSystemProps>` | `rxFsProps​(String path)` | Returns properties of the file-system being used by the specified `path`, asynchronously.
    `Completable` | `rxLink​(String link, String existing)` | Create a hard link on the file system from `link` to `existing`, asynchronously.
    `Single<FileProps>` | `rxLprops​(String path)` | Obtain properties for the link represented by `path`, asynchronously.
    `Completable` | `rxMkdir​(String path)` | Create the directory represented by `path`, asynchronously.
    `Completable` | `rxMkdir​(String path, String perms)` | Create the directory represented by `path`, asynchronously.
    `Completable` | `rxMkdirs​(String path)` | Create the directory represented by `path` and any non existent parents, asynchronously.
    `Completable` | `rxMkdirs​(String path, String perms)` | Create the directory represented by `path` and any non existent parents, asynchronously.
    `Completable` | `rxMove​(String from, String to)` | Move a file from the path `from` to path `to`, asynchronously.
    `Completable` | `rxMove​(String from, String to, CopyOptions options)` | Move a file from the path `from` to path `to`, asynchronously.
    `Single<AsyncFile>` | `rxOpen​(String path, OpenOptions options)` | Open the file represented by `path`, asynchronously.
    `Single<FileProps>` | `rxProps​(String path)` | Obtain properties for the file represented by `path`, asynchronously.
    `Single<List<String>>` | `rxReadDir​(String path)` | Read the contents of the directory specified by `path`, asynchronously.
    `Single<List<String>>` | `rxReadDir​(String path, String filter)` | Read the contents of the directory specified by `path`, asynchronously.
    `Single<Buffer>` | `rxReadFile​(String path)` | Reads the entire file as represented by the path `path` as a , asynchronously.
    `Single<String>` | `rxReadSymlink​(String link)` | Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
    `Completable` | `rxSymlink​(String link, String existing)` | Create a symbolic link on the file system from `link` to `existing`, asynchronously.
    `Completable` | `rxTruncate​(String path, long len)` | Truncate the file represented by `path` to length `len` in bytes, asynchronously.
    `Completable` | `rxUnlink​(String link)` | Unlinks the link on the file system represented by the path `link`, asynchronously.
    `Completable` | `rxWriteFile​(String path, Buffer data)` | Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
    `Completable` | `symlink​(String link, String existing)` | Create a symbolic link on the file system from `link` to `existing`, asynchronously.
    `FileSystem` | `symlinkBlocking​(String link, String existing)` | Blocking version of `link(java.lang.String, java.lang.String)`
    `String` | `toString()` |
    `Completable` | `truncate​(String path, long len)` | Truncate the file represented by `path` to length `len` in bytes, asynchronously.
    `FileSystem` | `truncateBlocking​(String path, long len)` | Blocking version of `truncate(java.lang.String, long)`
    `Completable` | `unlink​(String link)` | Unlinks the link on the file system represented by the path `link`, asynchronously.
    `FileSystem` | `unlinkBlocking​(String link)` | Blocking version of `unlink(java.lang.String)`
    `Completable` | `writeFile​(String path, Buffer data)` | Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
    `FileSystem` | `writeFileBlocking​(String path, Buffer data)` | Blocking version of `writeFile(java.lang.String, io.vertx.core.buffer.Buffer)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<FileSystem> __TYPE_ARG

  - ### Constructor Detail

    - #### FileSystem

          public FileSystem​(FileSystem delegate)

    - #### FileSystem

          public FileSystem​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public FileSystem getDelegate()

    - #### copy

          public Completable copy​(String from,
                                  String to)

      Copy a file from the path `from` to path `to`, asynchronously.

      The copy will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:
        a future notified on completion

    - #### rxCopy

          public Completable rxCopy​(String from,
                                    String to)

      Copy a file from the path `from` to path `to`, asynchronously.

      The copy will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:
        a future notified on completion

    - #### copy

          public Completable copy​(String from,
                                  String to,
                                  CopyOptions options)

      Copy a file from the path `from` to path `to`, asynchronously.
      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `options` - options describing how the file should be copied
      Returns:
        a future notified on completion

    - #### rxCopy

          public Completable rxCopy​(String from,
                                    String to,
                                    CopyOptions options)

      Copy a file from the path `from` to path `to`, asynchronously.
      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `options` - options describing how the file should be copied
      Returns:
        a future notified on completion

    - #### copyBlocking

          public FileSystem copyBlocking​(String from,
                                         String to)

      Blocking version of `copy(java.lang.String, java.lang.String)`
      Parameters:
        `from` -
        `to` -
      Returns:

    - #### copyRecursive

          public Completable copyRecursive​(String from,
                                           String to,
                                           boolean recursive)

      Copy a file from the path `from` to path `to`, asynchronously.

      If `recursive` is `true` and `from` represents a directory, then the directory and its contents will be copied recursively to the destination `to`.

      The copy will fail if the destination if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `recursive` -
      Returns:
        a future notified on completion

    - #### rxCopyRecursive

          public Completable rxCopyRecursive​(String from,
                                             String to,
                                             boolean recursive)

      Copy a file from the path `from` to path `to`, asynchronously.

      If `recursive` is `true` and `from` represents a directory, then the directory and its contents will be copied recursively to the destination `to`.

      The copy will fail if the destination if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `recursive` -
      Returns:
        a future notified on completion

    - #### copyRecursiveBlocking

          public FileSystem copyRecursiveBlocking​(String from,
                                                  String to,
                                                  boolean recursive)

      Blocking version of `copyRecursive(java.lang.String, java.lang.String, boolean)`
      Parameters:
        `from` -
        `to` -
        `recursive` -
      Returns:

    - #### move

          public Completable move​(String from,
                                  String to)

      Move a file from the path `from` to path `to`, asynchronously.

      The move will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:
        a future notified on completion

    - #### rxMove

          public Completable rxMove​(String from,
                                    String to)

      Move a file from the path `from` to path `to`, asynchronously.

      The move will fail if the destination already exists.

      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
      Returns:
        a future notified on completion

    - #### move

          public Completable move​(String from,
                                  String to,
                                  CopyOptions options)

      Move a file from the path `from` to path `to`, asynchronously.
      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `options` - options describing how the file should be copied
      Returns:
        a future notified on completion

    - #### rxMove

          public Completable rxMove​(String from,
                                    String to,
                                    CopyOptions options)

      Move a file from the path `from` to path `to`, asynchronously.
      Parameters:
        `from` - the path to copy from
        `to` - the path to copy to
        `options` - options describing how the file should be copied
      Returns:
        a future notified on completion

    - #### moveBlocking

          public FileSystem moveBlocking​(String from,
                                         String to)

      Blocking version of `move(java.lang.String, java.lang.String)`
      Parameters:
        `from` -
        `to` -
      Returns:

    - #### truncate

          public Completable truncate​(String path,
                                      long len)

      Truncate the file represented by `path` to length `len` in bytes, asynchronously.

      The operation will fail if the file does not exist or `len` is less than `zero`.

      Parameters:
        `path` - the path to the file
        `len` - the length to truncate it to
      Returns:
        a future notified on completion

    - #### rxTruncate

          public Completable rxTruncate​(String path,
                                        long len)

      Truncate the file represented by `path` to length `len` in bytes, asynchronously.

      The operation will fail if the file does not exist or `len` is less than `zero`.

      Parameters:
        `path` - the path to the file
        `len` - the length to truncate it to
      Returns:
        a future notified on completion

    - #### truncateBlocking

          public FileSystem truncateBlocking​(String path,
                                             long len)

      Blocking version of `truncate(java.lang.String, long)`
      Parameters:
        `path` -
        `len` -
      Returns:

    - #### chmod

          public Completable chmod​(String path,
                                   String perms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified here.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxChmod

          public Completable rxChmod​(String path,
                                     String perms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified here.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### chmodBlocking

          public FileSystem chmodBlocking​(String path,
                                          String perms)

      Blocking version of `#chmod(String, String)`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### chmodRecursive

          public Completable chmodRecursive​(String path,
                                            String perms,
                                            String dirPerms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified in {here}.

      If the file is directory then all contents will also have their permissions changed recursively. Any directory permissions will be set to `dirPerms`, whilst any normal file permissions will be set to `perms`.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
        `dirPerms` - the directory permissions
      Returns:
        a future notified on completion

    - #### rxChmodRecursive

          public Completable rxChmodRecursive​(String path,
                                              String perms,
                                              String dirPerms)

      Change the permissions on the file represented by `path` to `perms`, asynchronously.

      The permission String takes the form rwxr-x--- as specified in {here}.

      If the file is directory then all contents will also have their permissions changed recursively. Any directory permissions will be set to `dirPerms`, whilst any normal file permissions will be set to `perms`.

      Parameters:
        `path` - the path to the file
        `perms` - the permissions string
        `dirPerms` - the directory permissions
      Returns:
        a future notified on completion

    - #### chmodRecursiveBlocking

          public FileSystem chmodRecursiveBlocking​(String path,
                                                   String perms,
                                                   String dirPerms)

      Blocking version of `chmodRecursive(java.lang.String, java.lang.String, java.lang.String)`
      Parameters:
        `path` -
        `perms` -
        `dirPerms` -
      Returns:

    - #### chown

          public Completable chown​(String path,
                                   String user,
                                   String group)

      Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
      Parameters:
        `path` - the path to the file
        `user` - the user name, `null` will not change the user name
        `group` - the user group, `null` will not change the user group name
      Returns:
        a future notified on completion

    - #### rxChown

          public Completable rxChown​(String path,
                                     String user,
                                     String group)

      Change the ownership on the file represented by `path` to `user` and {code group}, asynchronously.
      Parameters:
        `path` - the path to the file
        `user` - the user name, `null` will not change the user name
        `group` - the user group, `null` will not change the user group name
      Returns:
        a future notified on completion

    - #### chownBlocking

          public FileSystem chownBlocking​(String path,
                                          String user,
                                          String group)

      Blocking version of `chown(java.lang.String, java.lang.String, java.lang.String)`
      Parameters:
        `path` -
        `user` -
        `group` -
      Returns:

    - #### props

          public Single<FileProps> props​(String path)

      Obtain properties for the file represented by `path`, asynchronously.

      If the file is a link, the link will be followed.

      Parameters:
        `path` - the path to the file
      Returns:
        a future notified on completion

    - #### rxProps

          public Single<FileProps> rxProps​(String path)

      Obtain properties for the file represented by `path`, asynchronously.

      If the file is a link, the link will be followed.

      Parameters:
        `path` - the path to the file
      Returns:
        a future notified on completion

    - #### propsBlocking

          public FileProps propsBlocking​(String path)

      Blocking version of `props(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### lprops

          public Single<FileProps> lprops​(String path)

      Obtain properties for the link represented by `path`, asynchronously.

      The link will not be followed.

      Parameters:
        `path` - the path to the file
      Returns:
        a future notified on completion

    - #### rxLprops

          public Single<FileProps> rxLprops​(String path)

      Obtain properties for the link represented by `path`, asynchronously.

      The link will not be followed.

      Parameters:
        `path` - the path to the file
      Returns:
        a future notified on completion

    - #### lpropsBlocking

          public FileProps lpropsBlocking​(String path)

      Blocking version of `lprops(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### link

          public Completable link​(String link,
                                  String existing)

      Create a hard link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:
        a future notified on completion

    - #### rxLink

          public Completable rxLink​(String link,
                                    String existing)

      Create a hard link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:
        a future notified on completion

    - #### linkBlocking

          public FileSystem linkBlocking​(String link,
                                         String existing)

      Blocking version of `link(java.lang.String, java.lang.String)`
      Parameters:
        `link` -
        `existing` -
      Returns:

    - #### symlink

          public Completable symlink​(String link,
                                     String existing)

      Create a symbolic link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:
        a future notified on completion

    - #### rxSymlink

          public Completable rxSymlink​(String link,
                                       String existing)

      Create a symbolic link on the file system from `link` to `existing`, asynchronously.
      Parameters:
        `link` - the link
        `existing` - the link destination
      Returns:
        a future notified on completion

    - #### symlinkBlocking

          public FileSystem symlinkBlocking​(String link,
                                            String existing)

      Blocking version of `link(java.lang.String, java.lang.String)`
      Parameters:
        `link` -
        `existing` -
      Returns:

    - #### unlink

          public Completable unlink​(String link)

      Unlinks the link on the file system represented by the path `link`, asynchronously.
      Parameters:
        `link` - the link
      Returns:
        a future notified on completion

    - #### rxUnlink

          public Completable rxUnlink​(String link)

      Unlinks the link on the file system represented by the path `link`, asynchronously.
      Parameters:
        `link` - the link
      Returns:
        a future notified on completion

    - #### unlinkBlocking

          public FileSystem unlinkBlocking​(String link)

      Blocking version of `unlink(java.lang.String)`
      Parameters:
        `link` -
      Returns:

    - #### readSymlink

          public Single<String> readSymlink​(String link)

      Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
      Parameters:
        `link` - the link
      Returns:
        a future notified on completion

    - #### rxReadSymlink

          public Single<String> rxReadSymlink​(String link)

      Returns the path representing the file that the symbolic link specified by `link` points to, asynchronously.
      Parameters:
        `link` - the link
      Returns:
        a future notified on completion

    - #### readSymlinkBlocking

          public String readSymlinkBlocking​(String link)

      Blocking version of `readSymlink(java.lang.String)`
      Parameters:
        `link` -
      Returns:

    - #### delete

          public Completable delete​(String path)

      Deletes the file represented by the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxDelete

          public Completable rxDelete​(String path)

      Deletes the file represented by the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### deleteBlocking

          public FileSystem deleteBlocking​(String path)

      Blocking version of `delete(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### deleteRecursive

          public Completable deleteRecursive​(String path,
                                             boolean recursive)

      Deletes the file represented by the specified `path`, asynchronously.

      If the path represents a directory and `recursive = true` then the directory and its contents will be deleted recursively.

      Parameters:
        `path` - path to the file
        `recursive` - delete recursively?
      Returns:
        a future notified on completion

    - #### rxDeleteRecursive

          public Completable rxDeleteRecursive​(String path,
                                               boolean recursive)

      Deletes the file represented by the specified `path`, asynchronously.

      If the path represents a directory and `recursive = true` then the directory and its contents will be deleted recursively.

      Parameters:
        `path` - path to the file
        `recursive` - delete recursively?
      Returns:
        a future notified on completion

    - #### deleteRecursiveBlocking

          public FileSystem deleteRecursiveBlocking​(String path,
                                                    boolean recursive)

      Blocking version of `deleteRecursive(java.lang.String, boolean)`
      Parameters:
        `path` -
        `recursive` -
      Returns:

    - #### mkdir

          public Completable mkdir​(String path)

      Create the directory represented by `path`, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxMkdir

          public Completable rxMkdir​(String path)

      Create the directory represented by `path`, asynchronously.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### mkdirBlocking

          public FileSystem mkdirBlocking​(String path)

      Blocking version of `mkdir(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### mkdir

          public Completable mkdir​(String path,
                                   String perms)

      Create the directory represented by `path`, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxMkdir

          public Completable rxMkdir​(String path,
                                     String perms)

      Create the directory represented by `path`, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the directory already exists.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### mkdirBlocking

          public FileSystem mkdirBlocking​(String path,
                                          String perms)

      Blocking version of `mkdir(java.lang.String)`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### mkdirs

          public Completable mkdirs​(String path)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The operation will fail if the `path` already exists but is not a directory.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxMkdirs

          public Completable rxMkdirs​(String path)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The operation will fail if the `path` already exists but is not a directory.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### mkdirsBlocking

          public FileSystem mkdirsBlocking​(String path)

      Blocking version of `mkdirs(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### mkdirs

          public Completable mkdirs​(String path,
                                    String perms)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the `path` already exists but is not a directory.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxMkdirs

          public Completable rxMkdirs​(String path,
                                      String perms)

      Create the directory represented by `path` and any non existent parents, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      The operation will fail if the `path` already exists but is not a directory.

      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### mkdirsBlocking

          public FileSystem mkdirsBlocking​(String path,
                                           String perms)

      Blocking version of `mkdirs(java.lang.String)`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### readDir

          public Single<List<String>> readDir​(String path)

      Read the contents of the directory specified by `path`, asynchronously.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxReadDir

          public Single<List<String>> rxReadDir​(String path)

      Read the contents of the directory specified by `path`, asynchronously.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### readDirBlocking

          public List<String> readDirBlocking​(String path)

      Blocking version of `readDir(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### readDir

          public Single<List<String>> readDir​(String path,
                                              String filter)

      Read the contents of the directory specified by `path`, asynchronously.

      The parameter `filter` is a regular expression. If `filter` is specified then only the paths that match @{filter}will be returned.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the directory
        `filter` - the filter expression
      Returns:
        a future notified on completion

    - #### rxReadDir

          public Single<List<String>> rxReadDir​(String path,
                                                String filter)

      Read the contents of the directory specified by `path`, asynchronously.

      The parameter `filter` is a regular expression. If `filter` is specified then only the paths that match @{filter}will be returned.

      The result is an array of String representing the paths of the files inside the directory.

      Parameters:
        `path` - path to the directory
        `filter` - the filter expression
      Returns:
        a future notified on completion

    - #### readDirBlocking

          public List<String> readDirBlocking​(String path,
                                              String filter)

      Blocking version of `readDir(java.lang.String)`
      Parameters:
        `path` -
        `filter` -
      Returns:

    - #### readFile

          public Single<Buffer> readFile​(String path)

      Reads the entire file as represented by the path `path` as a , asynchronously.

      Do not use this method to read very large files or you risk running out of available RAM.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxReadFile

          public Single<Buffer> rxReadFile​(String path)

      Reads the entire file as represented by the path `path` as a , asynchronously.

      Do not use this method to read very large files or you risk running out of available RAM.

      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### readFileBlocking

          public Buffer readFileBlocking​(String path)

      Blocking version of `readFile(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### writeFile

          public Completable writeFile​(String path,
                                       Buffer data)

      Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `data` -
      Returns:
        a future notified on completion

    - #### rxWriteFile

          public Completable rxWriteFile​(String path,
                                         Buffer data)

      Creates the file, and writes the specified `Buffer data` to the file represented by the path `path`, asynchronously.
      Parameters:
        `path` - path to the file
        `data` -
      Returns:
        a future notified on completion

    - #### writeFileBlocking

          public FileSystem writeFileBlocking​(String path,
                                              Buffer data)

      Blocking version of `writeFile(java.lang.String, io.vertx.core.buffer.Buffer)`
      Parameters:
        `path` -
        `data` -
      Returns:

    - #### open

          public Single<AsyncFile> open​(String path,
                                        OpenOptions options)

      Open the file represented by `path`, asynchronously.

      The file is opened for both reading and writing. If the file does not already exist it will be created.

      Parameters:
        `path` - path to the file
        `options` - options describing how the file should be opened
      Returns:
        a future notified on completion

    - #### rxOpen

          public Single<AsyncFile> rxOpen​(String path,
                                          OpenOptions options)

      Open the file represented by `path`, asynchronously.

      The file is opened for both reading and writing. If the file does not already exist it will be created.

      Parameters:
        `path` - path to the file
        `options` - options describing how the file should be opened
      Returns:
        a future notified on completion

    - #### openBlocking

          public AsyncFile openBlocking​(String path,
                                        OpenOptions options)

      Blocking version of `open(java.lang.String, io.vertx.core.file.OpenOptions)`
      Parameters:
        `path` -
        `options` -
      Returns:

    - #### createFile

          public Completable createFile​(String path)

      Creates an empty file with the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxCreateFile

          public Completable rxCreateFile​(String path)

      Creates an empty file with the specified `path`, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### createFileBlocking

          public FileSystem createFileBlocking​(String path)

      Blocking version of `createFile(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### createFile

          public Completable createFile​(String path,
                                        String perms)

      Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxCreateFile

          public Completable rxCreateFile​(String path,
                                          String perms)

      Creates an empty file with the specified `path` and permissions `perms`, asynchronously.
      Parameters:
        `path` - path to the file
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### createFileBlocking

          public FileSystem createFileBlocking​(String path,
                                               String perms)

      Blocking version of `createFile(java.lang.String)`
      Parameters:
        `path` -
        `perms` -
      Returns:

    - #### exists

          public Single<Boolean> exists​(String path)

      Determines whether the file as specified by the path `path` exists, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### rxExists

          public Single<Boolean> rxExists​(String path)

      Determines whether the file as specified by the path `path` exists, asynchronously.
      Parameters:
        `path` - path to the file
      Returns:
        a future notified on completion

    - #### existsBlocking

          public boolean existsBlocking​(String path)

      Blocking version of `exists(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### fsProps

          public Single<FileSystemProps> fsProps​(String path)

      Returns properties of the file-system being used by the specified `path`, asynchronously.
      Parameters:
        `path` - path to anywhere on the filesystem
      Returns:
        a future notified on completion

    - #### rxFsProps

          public Single<FileSystemProps> rxFsProps​(String path)

      Returns properties of the file-system being used by the specified `path`, asynchronously.
      Parameters:
        `path` - path to anywhere on the filesystem
      Returns:
        a future notified on completion

    - #### fsPropsBlocking

          public FileSystemProps fsPropsBlocking​(String path)

      Blocking version of `fsProps(java.lang.String)`
      Parameters:
        `path` -
      Returns:

    - #### createTempDirectory

          public Single<String> createTempDirectory​(String prefix)

      Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
      Returns:
        a future notified on completion

    - #### rxCreateTempDirectory

          public Single<String> rxCreateTempDirectory​(String prefix)

      Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
      Returns:
        a future notified on completion

    - #### createTempDirectoryBlocking

          public String createTempDirectoryBlocking​(String prefix)

      Blocking version of `createTempDirectory(java.lang.String)`
      Parameters:
        `prefix` -
      Returns:

    - #### createTempDirectory

          public Single<String> createTempDirectory​(String prefix,
                                                    String perms)

      Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxCreateTempDirectory

          public Single<String> rxCreateTempDirectory​(String prefix,
                                                      String perms)

      Creates a new directory in the default temporary-file directory, using the given prefix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### createTempDirectoryBlocking

          public String createTempDirectoryBlocking​(String prefix,
                                                    String perms)

      Blocking version of `createTempDirectory(java.lang.String)`
      Parameters:
        `prefix` -
        `perms` -
      Returns:

    - #### createTempDirectory

          public Single<String> createTempDirectory​(String dir,
                                                    String prefix,
                                                    String perms)

      Creates a new directory in the directory provided by the path `path`, using the given prefix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `dir` - the path to directory in which to create the directory
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxCreateTempDirectory

          public Single<String> rxCreateTempDirectory​(String dir,
                                                      String prefix,
                                                      String perms)

      Creates a new directory in the directory provided by the path `path`, using the given prefix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `dir` - the path to directory in which to create the directory
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### createTempDirectoryBlocking

          public String createTempDirectoryBlocking​(String dir,
                                                    String prefix,
                                                    String perms)

      Blocking version of `createTempDirectory(java.lang.String)`
      Parameters:
        `dir` -
        `prefix` -
        `perms` -
      Returns:

    - #### createTempFile

          public Single<String> createTempFile​(String prefix,
                                               String suffix)

      Creates a new file in the default temporary-file directory, using the given prefix and suffix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
      Returns:
        a future notified on completion

    - #### rxCreateTempFile

          public Single<String> rxCreateTempFile​(String prefix,
                                                 String suffix)

      Creates a new file in the default temporary-file directory, using the given prefix and suffix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
      Returns:
        a future notified on completion

    - #### createTempFileBlocking

          public String createTempFileBlocking​(String prefix,
                                               String suffix)

      Blocking version of `createTempFile(java.lang.String, java.lang.String)`
      Parameters:
        `prefix` -
        `suffix` -
      Returns:

    - #### createTempFile

          public Single<String> createTempFile​(String prefix,
                                               String suffix,
                                               String perms)

      Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
        `perms` -
      Returns:
        a future notified on completion

    - #### rxCreateTempFile

          public Single<String> rxCreateTempFile​(String prefix,
                                                 String suffix,
                                                 String perms)

      Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
        `perms` -
      Returns:
        a future notified on completion

    - #### createTempFileBlocking

          public String createTempFileBlocking​(String prefix,
                                               String suffix,
                                               String perms)

      Blocking version of `createTempFile(java.lang.String, java.lang.String)`
      Parameters:
        `prefix` -
        `suffix` -
        `perms` -
      Returns:

    - #### createTempFile

          public Single<String> createTempFile​(String dir,
                                               String prefix,
                                               String suffix,
                                               String perms)

      Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `dir` - the path to directory in which to create the directory
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### rxCreateTempFile

          public Single<String> rxCreateTempFile​(String dir,
                                                 String prefix,
                                                 String suffix,
                                                 String perms)

      Creates a new file in the directory provided by the path `dir`, using the given prefix and suffix to generate its name, asynchronously.

      The new directory will be created with permissions as specified by `perms`.

      The permission String takes the form rwxr-x--- as specified in here.

      As with the `File.createTempFile` methods, this method is only part of a temporary-file facility.A `Runtime`, or the `File` mechanism may be used to delete the directory automatically.

      Parameters:
        `dir` - the path to directory in which to create the directory
        `prefix` - the prefix string to be used in generating the directory's name; may be `null`
        `suffix` - the suffix string to be used in generating the file's name; may be `null`, in which case "`.tmp`" is used
        `perms` - the permissions string
      Returns:
        a future notified on completion

    - #### createTempFileBlocking

          public String createTempFileBlocking​(String dir,
                                               String prefix,
                                               String suffix,
                                               String perms)

      Blocking version of `createTempFile(java.lang.String, java.lang.String)`
      Parameters:
        `dir` -
        `prefix` -
        `suffix` -
        `perms` -
      Returns:

    - #### newInstance

          public static FileSystem newInstance​(FileSystem arg)